import sys

def solve(l, r, a, n):
    pass

n, q = map(int, sys.stdin.readline().split())
a = list(map(int, sys.stdin.readline().split()))

for _ in range(q):
    q1 = list(map(int, sys.stdin.readline().split()))
    if q1[0] == 1:
        a[q1[1]-1] = -a[q1[1]-1]
    else:
        print(abs(q1[1]-q1[2])+1)
